Fix: rseq: arm branch to failure
[deliverable/linux.git] / scripts / Makefile.gcc-plugins
1 ifdef CONFIG_GCC_PLUGINS
2 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
4
5 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
6
7 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
8
9 ifdef CONFIG_GCC_PLUGIN_SANCOV
10 ifeq ($(CFLAGS_KCOV),)
11 # It is needed because of the gcc-plugin.sh and gcc version checks.
12 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
13
14 ifneq ($(PLUGINCC),)
15 CFLAGS_KCOV := $(SANCOV_PLUGIN)
16 else
17 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
18 endif
19 endif
20 endif
21
22 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
23
24 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR SANCOV_PLUGIN
25
26 ifneq ($(PLUGINCC),)
27 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
28 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
29 endif
30
31 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
32 GCC_PLUGIN := $(gcc-plugin-y)
33 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
34 endif
35
36 # If plugins aren't supported, abort the build before hard-to-read compiler
37 # errors start getting spewed by the main build.
38 PHONY += gcc-plugins-check
39 gcc-plugins-check: FORCE
40 ifdef CONFIG_GCC_PLUGINS
41 ifeq ($(PLUGINCC),)
42 ifneq ($(GCC_PLUGINS_CFLAGS),)
43 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
44 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
45 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
46 else
47 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
48 endif
49 endif
50 endif
51 endif
52 @:
53
54 # Actually do the build, if requested.
55 PHONY += gcc-plugins
56 gcc-plugins: scripts_basic gcc-plugins-check
57 ifdef CONFIG_GCC_PLUGINS
58 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
59 endif
60 @:
This page took 0.032168 seconds and 5 git commands to generate.